# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from yandex_api_client.models.model_offer_dto import ModelOfferDTO
from yandex_api_client.models.model_price_dto import ModelPriceDTO
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class EnrichedModelDTO(BaseModel):
    """
    Модель товара.
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="Идентификатор модели товара.")
    name: Optional[StrictStr] = Field(default=None, description="Название модели товара.")
    prices: Optional[ModelPriceDTO] = None
    offers: Optional[List[ModelOfferDTO]] = Field(default=None, description="Список первых десяти предложений, расположенных на карточке модели.  В ответе на запрос возвращаются предложения различных магазинов. Если есть несколько предложений от одного магазина, в ответе отображается только одно, наиболее релевантное из них. ")
    offline_offers: Optional[StrictInt] = Field(default=None, description="Суммарное количество предложений в розничных магазинах в регионе. Учитываются все предложения от каждого магазина.", alias="offlineOffers")
    online_offers: Optional[StrictInt] = Field(default=None, description="Суммарное количество предложений в интернет-магазинах в регионе. Учитываются все предложения от каждого магазина.", alias="onlineOffers")
    __properties: ClassVar[List[str]] = ["id", "name", "prices", "offers", "offlineOffers", "onlineOffers"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of EnrichedModelDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of prices
        if self.prices:
            _dict['prices'] = self.prices.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in offers (list)
        _items = []
        if self.offers:
            for _item in self.offers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['offers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of EnrichedModelDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "prices": ModelPriceDTO.from_dict(obj.get("prices")) if obj.get("prices") is not None else None,
            "offers": [ModelOfferDTO.from_dict(_item) for _item in obj.get("offers")] if obj.get("offers") is not None else None,
            "offlineOffers": obj.get("offlineOffers"),
            "onlineOffers": obj.get("onlineOffers")
        })
        return _obj


