# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from yandex_api_client.models.feed_content_dto import FeedContentDTO
from yandex_api_client.models.feed_download_dto import FeedDownloadDTO
from yandex_api_client.models.feed_placement_dto import FeedPlacementDTO
from yandex_api_client.models.feed_publication_dto import FeedPublicationDTO
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class FeedDTO(BaseModel):
    """
    Информация о прайс-листе.
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="Идентификатор прайс-листа.")
    login: Optional[StrictStr] = Field(default=None, description="Логин для авторизации при скачивании прайс-листа. Параметр выводится при размещении прайс-листа на сайте магазина и в случае ограничения доступа к нему. ")
    name: Optional[StrictStr] = Field(default=None, description="Имя файла, содержащего прайс-лист. Параметр выводится при размещении прайс-листа на сервере Маркета. ")
    password: Optional[StrictStr] = Field(default=None, description="Пароль для авторизации при скачивании прайс-листа. Параметр выводится при размещении прайс-листа на сайте магазина и в случае ограничения доступа к нему. ")
    upload_date: Optional[datetime] = Field(default=None, description="Дата загрузки прайс-листа на Маркет. Формат даты: `ДД-ММ-ГГГГ`. Параметр выводится при размещении прайс-листа на сервере Маркета. ", alias="uploadDate")
    url: Optional[StrictStr] = Field(default=None, description="URL прайс-листа. Параметр выводится при размещении прайс-листа на сайте магазина. ")
    content: Optional[FeedContentDTO] = None
    download: Optional[FeedDownloadDTO] = None
    placement: Optional[FeedPlacementDTO] = None
    publication: Optional[FeedPublicationDTO] = None
    __properties: ClassVar[List[str]] = ["id", "login", "name", "password", "uploadDate", "url", "content", "download", "placement", "publication"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of FeedDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of content
        if self.content:
            _dict['content'] = self.content.to_dict()
        # override the default output from pydantic by calling `to_dict()` of download
        if self.download:
            _dict['download'] = self.download.to_dict()
        # override the default output from pydantic by calling `to_dict()` of placement
        if self.placement:
            _dict['placement'] = self.placement.to_dict()
        # override the default output from pydantic by calling `to_dict()` of publication
        if self.publication:
            _dict['publication'] = self.publication.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of FeedDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "login": obj.get("login"),
            "name": obj.get("name"),
            "password": obj.get("password"),
            "uploadDate": obj.get("uploadDate"),
            "url": obj.get("url"),
            "content": FeedContentDTO.from_dict(obj.get("content")) if obj.get("content") is not None else None,
            "download": FeedDownloadDTO.from_dict(obj.get("download")) if obj.get("download") is not None else None,
            "placement": FeedPlacementDTO.from_dict(obj.get("placement")) if obj.get("placement") is not None else None,
            "publication": FeedPublicationDTO.from_dict(obj.get("publication")) if obj.get("publication") is not None else None
        })
        return _obj


