# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt
from pydantic import Field
from yandex_api_client.models.feed_index_logs_feed_dto import FeedIndexLogsFeedDTO
from yandex_api_client.models.feed_index_logs_record_dto import FeedIndexLogsRecordDTO
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class FeedIndexLogsResultDTO(BaseModel):
    """
    Результат выполнения запроса отчета по индексации прайс-листа.
    """ # noqa: E501
    feed: Optional[FeedIndexLogsFeedDTO] = None
    index_log_records: Optional[List[FeedIndexLogsRecordDTO]] = Field(default=None, description="Список отчетов по индексации прайс-листа.", alias="indexLogRecords")
    total: Optional[StrictInt] = Field(default=None, description="Количество отчетов на всех страницах выходных данных.")
    __properties: ClassVar[List[str]] = ["feed", "indexLogRecords", "total"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of FeedIndexLogsResultDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of feed
        if self.feed:
            _dict['feed'] = self.feed.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in index_log_records (list)
        _items = []
        if self.index_log_records:
            for _item in self.index_log_records:
                if _item:
                    _items.append(_item.to_dict())
            _dict['indexLogRecords'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of FeedIndexLogsResultDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "feed": FeedIndexLogsFeedDTO.from_dict(obj.get("feed")) if obj.get("feed") is not None else None,
            "indexLogRecords": [FeedIndexLogsRecordDTO.from_dict(_item) for _item in obj.get("indexLogRecords")] if obj.get("indexLogRecords") is not None else None,
            "total": obj.get("total")
        })
        return _obj


