# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt
from pydantic import Field
from yandex_api_client.models.shows_sales_grouping_type import ShowsSalesGroupingType
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GenerateShowsSalesReportRequest(BaseModel):
    """
    Данные, необходимые для генерации отчета.
    """ # noqa: E501
    business_id: Optional[StrictInt] = Field(default=None, description="Идентификатор бизнеса.  Указывается, если нужно составить отчет по всем магазинам бизнеса. В запросе обязательно должен быть либо `businessID`, либо `campaignId`, но не оба сразу. ", alias="businessId")
    campaign_id: Optional[StrictInt] = Field(default=None, description="Идентификатор кампании.  Указывается, если нужно составить отчет по конкретному магазину. В запросе обязательно должен быть либо `businessID`, либо `campaignId`, но не оба сразу. ", alias="campaignId")
    date_from: date = Field(description="Начало периода, включительно.", alias="dateFrom")
    date_to: date = Field(description="Конец периода, включительно.", alias="dateTo")
    grouping: ShowsSalesGroupingType
    __properties: ClassVar[List[str]] = ["businessId", "campaignId", "dateFrom", "dateTo", "grouping"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GenerateShowsSalesReportRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GenerateShowsSalesReportRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "businessId": obj.get("businessId"),
            "campaignId": obj.get("campaignId"),
            "dateFrom": obj.get("dateFrom"),
            "dateTo": obj.get("dateTo"),
            "grouping": obj.get("grouping")
        })
        return _obj


