# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from pydantic import Field
from yandex_api_client.models.hidden_offer_dto import HiddenOfferDTO
from yandex_api_client.models.scrolling_pager_dto import ScrollingPagerDTO
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GetHiddenOffersResultDTO(BaseModel):
    """
    Список скрытых вами товаров. 
    """ # noqa: E501
    paging: Optional[ScrollingPagerDTO] = None
    hidden_offers: Optional[List[HiddenOfferDTO]] = Field(default=None, description="Список скрытых товаров.", alias="hiddenOffers")
    __properties: ClassVar[List[str]] = ["paging", "hiddenOffers"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GetHiddenOffersResultDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of paging
        if self.paging:
            _dict['paging'] = self.paging.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in hidden_offers (list)
        _items = []
        if self.hidden_offers:
            for _item in self.hidden_offers:
                if _item:
                    _items.append(_item.to_dict())
            _dict['hiddenOffers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GetHiddenOffersResultDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "paging": ScrollingPagerDTO.from_dict(obj.get("paging")) if obj.get("paging") is not None else None,
            "hiddenOffers": [HiddenOfferDTO.from_dict(_item) for _item in obj.get("hiddenOffers")] if obj.get("hiddenOffers") is not None else None
        })
        return _obj


