# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictInt, StrictStr, field_validator
from pydantic import Field
from typing_extensions import Annotated
from yandex_api_client.models.offer_card_status_type import OfferCardStatusType
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GetOfferMappingsRequest(BaseModel):
    """
    GetOfferMappingsRequest
    """ # noqa: E501
    offer_ids: Optional[Annotated[List[Annotated[str, Field(min_length=1, strict=True, max_length=80)]], Field(max_length=200)]] = Field(default=None, description="Идентификаторы товаров, информация о которых нужна.  {% note warning \"Такой список возвращается только целиком\" %}  Если вы запрашиваете информацию по конкретным SKU, не заполняйте: * `page_token`; * `limit`; * `cardStatuses`; * `categoryIds`; * `vendorNames`; * `tags`; * `archived`.  {% endnote %}    ", alias="offerIds")
    card_statuses: Optional[List[OfferCardStatusType]] = Field(default=None, description="Фильтр по статусам карточек.  [Что такое карточка товара](https://yandex.ru/support/marketplace/assortment/content/index.html) ", alias="cardStatuses")
    category_ids: Optional[List[StrictInt]] = Field(default=None, description="Фильтр по категориям на Маркете.", alias="categoryIds")
    vendor_names: Optional[List[StrictStr]] = Field(default=None, description="Фильтр по брендам.", alias="vendorNames")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Фильтр по тегам.")
    archived: Optional[StrictBool] = Field(default=None, description="Фильтр по нахождению в архиве.  Передайте `true`, чтобы получить товары, находящиеся в архиве. Если фильтр не заполнен или передано `false`, в ответе возвращаются товары, не находящиеся в архиве. ")
    __properties: ClassVar[List[str]] = ["offerIds", "cardStatuses", "categoryIds", "vendorNames", "tags", "archived"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GetOfferMappingsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GetOfferMappingsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "offerIds": obj.get("offerIds"),
            "cardStatuses": obj.get("cardStatuses"),
            "categoryIds": obj.get("categoryIds"),
            "vendorNames": obj.get("vendorNames"),
            "tags": obj.get("tags"),
            "archived": obj.get("archived")
        })
        return _obj


