# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
import re  # noqa: F401
from enum import Enum



try:
    from typing import Self
except ImportError:
    from typing_extensions import Self


class OfferCardRecommendationType(str, Enum):
    """
    Рекомендация по дополнению или замене контента.  Часть рекомендаций относятся к **основным параметрам**, которые есть у товаров любых категорий. Другие — к тем **характеристикам**, которые есть у товара потому, что он относится к определенной категории.  **1. Рекомендации, относящиеся к основным параметрам**  Каждая такая рекомендация относится к **единственному параметру**. Чтобы заполнить этот параметр, пользуйтесь запросом [POST businesses/{businessId}/offer-mappings/update](../../reference/business-assortment/updateOfferMappings.md).  Рекомендации по заполнению параметров в `updateOfferMappings`:  * `HAS_VIDEO` — добавьте на карточку видео (параметр `videos`). * `RECOGNIZED_VENDOR` — напишите название производителя так, как его пишет сам производитель (параметр `vendor`). * `PICTURE_COUNT` — добавьте изображения (параметр `pictures`). * `HAS_DESCRIPTION` — заполните описание (параметр `description`). * `HAS_BARCODE` — укажите штрихкод (параметр `barcode`). * `FIRST_PICTURE_SIZE` — замените первое изображение более крупным (параметр `pictures`).  **2. Рекомендации, относящиеся к характеристикам по категориям**  Каждая такая рекомендация предполагает заполнение **одной или нескольких характеристик**. Чтобы узнать, какие именно характеристики нужно заполнить, воспользуйтесь запросом [POST category/{categoryId}/parameters](../../reference/content/getCategoryContentParameters.md). Например, если вы получили рекомендацию `MAIN`, нужно заполнить характеристики, имеющие `MAIN` в массиве `recommendationTypes`.  Рекомендации:  * `MAIN` — заполните ключевые характеристики товара. * `ADDITIONAL` — заполните дополнительные характеристики товара. * `FILTERABLE` — заполните характеристики, используемые в фильтрах. * `DISTINCTIVE` — заполните характеристики, которыми отличаются друг от друга варианты товара. 
    """

    """
    allowed enum values
    """
    HAS_VIDEO = 'HAS_VIDEO'
    RECOGNIZED_VENDOR = 'RECOGNIZED_VENDOR'
    MAIN = 'MAIN'
    ADDITIONAL = 'ADDITIONAL'
    DISTINCTIVE = 'DISTINCTIVE'
    FILTERABLE = 'FILTERABLE'
    PICTURE_COUNT = 'PICTURE_COUNT'
    HAS_DESCRIPTION = 'HAS_DESCRIPTION'
    HAS_BARCODE = 'HAS_BARCODE'
    FIRST_PICTURE_SIZE = 'FIRST_PICTURE_SIZE'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of OfferCardRecommendationType from a JSON string"""
        return cls(json.loads(json_str))


