# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from pydantic import Field
from yandex_api_client.models.base_price_dto import BasePriceDTO
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class PriceCompetitivenessThresholdsDTO(BaseModel):
    """
    Максимальные значения цены, при которых она является привлекательной или умеренной.
    """ # noqa: E501
    optimal_price: Optional[BasePriceDTO] = Field(default=None, alias="optimalPrice")
    average_price: Optional[BasePriceDTO] = Field(default=None, alias="averagePrice")
    __properties: ClassVar[List[str]] = ["optimalPrice", "averagePrice"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PriceCompetitivenessThresholdsDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of optimal_price
        if self.optimal_price:
            _dict['optimalPrice'] = self.optimal_price.to_dict()
        # override the default output from pydantic by calling `to_dict()` of average_price
        if self.average_price:
            _dict['averagePrice'] = self.average_price.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PriceCompetitivenessThresholdsDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "optimalPrice": BasePriceDTO.from_dict(obj.get("optimalPrice")) if obj.get("optimalPrice") is not None else None,
            "averagePrice": BasePriceDTO.from_dict(obj.get("averagePrice")) if obj.get("averagePrice") is not None else None
        })
        return _obj


